unit uFrmCalc;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, uCalcThread;

type
  TFrmCalc = class(TForm)
    memMsg: TMemo;
    btnCalc: TButton;
    edtNum: TEdit;
    Label1: TLabel;
    edtMax: TEdit;
    Label2: TLabel;
    memInfo: TMemo;
    procedure btnCalcClick(Sender: TObject);
  private

    FMax: integer;
    FFinished: integer;
    FTotal: integer;

    procedure DispMsg(AMsg: string);
    procedure OnThreadMsg(AMsg: string);

    procedure Lock;
    procedure Unlock;

    procedure OnCalcOver(Sender: TCalcThread);

  public

  end;

var
  FrmCalc: TFrmCalc;

implementation

{$R *.dfm}

procedure TFrmCalc.btnCalcClick(Sender: TObject);
var
  BCalcThread: TCalcThread;
  BCalcInfo: TCalcInfo;
  nNum: integer;
  nSec: integer;
  i: integer;
begin

  btnCalc.Enabled := false; // Уֹ

  FFinished := 0;
  FTotal := 0;

  nNum := StrToIntDef(edtNum.Text, 100);

  FMax := StrToIntDef(edtMax.Text, 5);

  if FMax > 10 then
    FMax := 10;

  if FMax < 3 then
    FMax := 3;

  nSec := nNum div FMax; // ÿ̼߳ķΧδС(<5)

  BCalcInfo.OnMsg := self.OnThreadMsg;
  BCalcInfo.OnCalcOver := self.OnCalcOver;

  for i := 1 to FMax - 1 do
  begin
    BCalcInfo.StartNum := (i - 1) * nSec + 1;
    BCalcInfo.EndNum := i * nSec;
    BCalcInfo.ID := i;
    BCalcThread := TCalcThread.Create(BCalcInfo);
  end;

  BCalcInfo.StartNum := (FMax - 1) * nSec + 1;
  BCalcInfo.EndNum := nNum;
  BCalcInfo.ID := FMax;
  BCalcThread := TCalcThread.Create(BCalcInfo);

  // Ϊ BCalcThread 趨ΪԶͷŵģԲдͷŴ
  // ̵ִ߳н봴˳ûйϵ
  // ༸ΣַϢ˳ġ

end;

procedure TFrmCalc.DispMsg(AMsg: string);
//  AMsg Ϊʲô const?
// Ϊ const ֮ºӰӾ
// constЧʧ˴
// Ϊʲô TMemo ʾϢ
//  ShowMessage() ȥȷ
begin

  //  TMemo еϢ̫࣬Գ趨

  if memMsg.Lines.Count > 1000 then
    memMsg.Clear;

  memMsg.Lines.Add(AMsg);
end;

procedure TFrmCalc.Lock;
begin
  System.TMonitor.Enter(self);
  // delphi ߰ṩǳ򵥵ٽ
end;

procedure TFrmCalc.OnCalcOver(Sender: TCalcThread);
begin

  // ɴ˴ʼĴ룬ᱻ̵߳!

  Lock;

  // lock ԭӴ룬cpu ִ lock ʱͬʱִ lock

  //  磺i:=i+1,ͲһˣⲻԭӴ룬cpu ܻͬʱִж̵߳ i:=i+1;
  // ߳̿ͬʱִ i:=i+1;  i ĽԤϵġ

  // һ̻߳߳(߳A)ִlock ֮
  // ߳Aδִ unlock ֮ǰ
  // ߳BҲȥִ lock ,߳Block
  // 벻ȥֱ߳A unlock ߳BŻ

  try

    inc(FFinished);
    FTotal := FTotal + Sender.Sum;

    // lock סȷ벻ᱻ߳ͬʱִУ֤ȷԡ

    if FFinished >= FMax then
    begin

      OnThreadMsg('ۼӺ:' + IntTostr(FTotal));
      // ߳д룬ʾϢҪô˾䣬 DispMsg();

      TThread.Synchronize(nil,
        procedure
        begin
          btnCalc.Enabled := true;
        end);

      // ָť״̬Ϊ߳еĴ룬Ҫ߳ȥִ
    end;

  finally
    Unlock;
  end;

end;

procedure TFrmCalc.OnThreadMsg(AMsg: string);
begin
  // ɴ˴ʼĴ룬ִ߳е
  // ̴߳룬ܷ VCL : TMemo
  // Ҫ DispMsg()߳ȥִ
  //  XE2 ԺdelphiУTThread ṩĹܡ
  // TThread.Queue() ĵ2һ""
  // ˴׼ȷؽӦýС̡Ϊ㣬ͳơ
  //  delphi ߰汾е¹
  TThread.Queue(nil,
    procedure
    begin
      DispMsg(AMsg);
    end);
  //  TThread.Synchronize,ǵִٷأQueue ִж
  // ķʱ
end;

procedure TFrmCalc.Unlock;
begin
  System.TMonitor.exit(self);
end;

end.
